SystemOrganization addCategory: #DevPacerCommon!

!MethodModified methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:26'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!MethodAdded methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:26'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!MCModification methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:24'!
belongsToPackage: aMCPackage 
	^modification belongsToPackage: aMCPackage! !

!MCModification methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:21'!
literalKey
	^modification literalKey! !

!MCClassDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:29'!
belongsToPackage: aMCPackage 
	^aMCPackage packageInfo includesSystemCategory: category ! !

!MCClassDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:11'!
literalKey
	^{name}! !

!Morph methodsFor: '*DevPacerCommon' stamp: 'HwaJong 12/28/2012 16:22'!
openInDevPacerWindowLabeled: aString inWorld: aWorld
	"Changed to include the inset margin in the bound calculation."

	| window extent |
	window := (DevPacerWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth +
			(window class borderWidth * 2 @ (window class borderWidth + 1)). "include inset margin"
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

!CommentedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:09'!
asMCPatchOperation

	|newClassDef oldClassDef|
	newClassDef := item asMCDefinition.
	oldClassDef := newClassDef copy.
	oldClassDef instVarAt: (oldClassDef class instVarNames indexOf: 'comment') put: oldComment.
	^MCModification of: (oldClassDef) to: (newClassDef)! !

!CommentedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:50'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:each| each includesClass: item ]! !

!ClassRemoved methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:09'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!MCOrganizationDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:28'!
belongsToPackage: aMCPackage 
	^aMCPackage packageInfo includesSystemCategory: categories anyOne! !

!MCOrganizationDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:27'!
literalKey
	^categories! !

!CompiledMethod methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 11:24'!
asMCDefinition
	^MCMethodDefinition 
			className: (self methodClass name)
			classIsMeta: (self methodClass isMeta)
			selector: (self selector)
			category: (self category ifNil: [#'as yet unclassified'] ifNotNil: [:string| string])
			timeStamp: (self timeStamp) 
			source: (self sourceCode)! !

!CompiledMethod methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:42'!
itemIsIncludedInMonticelloPackage

	^PackageInfo allPackages anySatisfy: [:e| e includesMethod: (self selector) ofClass: self methodClass].! !

!CategoryRemoved methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:07'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

ColorPresenterMorph subclass: #ColorPresenterMorphForDevPacerTaskbarItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:52'!
handlesMouseDown: event
	^false! !

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:54'!
mouseDown: event
	self owner mouseDown: event! !

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:45'!
newHatchMorph
	"Answer a new morph showing a grid hatch pattern."

	^Morph new
		color: Color transparent;
		changeProportionalLayout;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		minWidth: 10;
		minHeight: 16;
		addMorph: (Morph new color: Color white)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 0.3@1));
		addMorph: (Morph new fillStyle: (InfiniteForm with: self hatchForm))
		fullFrame: (LayoutFrame fractions: (0.3@0 corner: 0.7@1));
		addMorph: self solidLabelMorph
		fullFrame: (LayoutFrame fractions: (0.7@0 corner: 1@1));
		addMorph: self labelMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

!RenamedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:37'!
asMCPatchOperation
	^MCModification of: (MCOrganizationDefinition categories: {oldName}) to: (MCOrganizationDefinition categories: {newName})! !

!RenamedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:35'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:each| (each includesSystemCategory: oldName) or: [each includesSystemCategory: newName] ]! !

!MCRemoval methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:53'!
belongsToPackage: aMCPackage 
	^definition belongsToPackage: aMCPackage! !

!MCRemoval methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:18'!
literalKey
	^definition literalKey! !

!MethodRemoved methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:26'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!Symbol methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 12:38'!
asMCDefinition
	^MCOrganizationDefinition categories: {self}! !

!Symbol methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:09'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:each| each name = self]! !

!MCMethodDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:27'!
belongsToPackage: aMCPackage 
	^aMCPackage packageInfo includesMethod: selector ofClass: ((Smalltalk classNamed: className) perform: (classIsMeta ifTrue: [#class] ifFalse: [#yourself]))! !

!MCMethodDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 12:31'!
literalKey
	^{className. selector}! !

!UITheme methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:19'!
newDevPacerTaskbarButtonIn: aTaskbar for: aWindow
	"Answer a taskbar button morph for the given window."

	|lm lab button labSize c1 c2 s |
	labSize := (150 // (aTaskbar tasks size + 1) max: 10) min: 30.
	lab := (self buttonLabelForText: (aWindow taskbarLabel truncateWithElipsisTo: labSize)).
	aWindow isActive
		ifTrue: [ lab emphasis: 1 "1 -> bold" ].
	lm := self
		newRowIn: aTaskbar
		for: {(aWindow taskbarIcon ifNil: [^nil]) asMorph. lab}.
	lm cellInset: 2.

	button := PluggableButtonMorph
			on: aWindow getState: #isActive action: #taskbarButtonClicked.
	button
		arguments: (#() ifNil: [{button}]);
		getEnabledSelector: nil;
		cornerStyle: (self buttonCornerStyleIn: aTaskbar);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		label: lm font: self buttonFont;
		setBalloonText: nil;
		yourself.
	
	button  listDirection: #leftToRight.  
	

	c1 := (ColorPresenterMorphForDevPacerTaskbarItem
			on: ImageSavePacer color: #statusColor)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'this show whether time has expired or not.'.
	c1 extent: 10@10.
	button addMorphBack: c1.
	c2 := (ColorPresenterMorphForDevPacerTaskbarItem
			on: CommitPacer color: #statusColor)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'this show whether time has expired or not.'.
	c2 extent: 10@10.
	button addMorphBack: c2.

	button
		wantsYellowButtonMenu: true;
		getMenuSelector: #taskbarButtonMenu:;
		on: #mouseEnter send: #taskbarButtonEntered:event:in: to: aWindow withValue: button;
		on: #mouseLeave send: #taskbarButtonLeft:event:in: to: aWindow withValue: button.
	aWindow isCollapsed
		ifTrue:  [ lab color: (self taskbarButtonLabelColorForCollapsed: button) ]
		ifFalse: [ lab color: (self taskbarButtonLabelColorForExpanded: button). ].
	^button! !

!ClassModifiedClassDefinition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:22'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!Behavior methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:22'!
asMCDefinition
	|nonMeta|
	nonMeta := self theNonMetaClass.
	^MCClassDefinition 
		name: (nonMeta name)
		superclassName: (nonMeta superclass name)
		traitComposition: (nonMeta traitComposition)
		classTraitComposition: (nonMeta class traitComposition )
		category: (nonMeta category)
		instVarNames: (nonMeta instVarNames)
		classVarNames: (nonMeta classVarNames)
		poolDictionaryNames: (nonMeta poolDictionaryNames)
		classInstVarNames: (nonMeta class instVarNames)
	 						type: (nonMeta typeOfClass)
		comment: (nonMeta instanceSide organization classComment)
		commentStamp: (nonMeta organization commentStamp)! !

!Behavior methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:55'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:pi| pi includesClass: self ]! !

!MCAddition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:28'!
belongsToPackage: aMCPackage 
	^definition belongsToPackage: aMCPackage ! !

!MCAddition methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:18'!
literalKey
	^definition literalKey! !

!ModifiedClassDefinitionEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 18:49'!
asMCPatchOperation
	^MCModification 
		of: (oldItem isMeta
			ifTrue: [item asMCDefinition]
			ifFalse: [oldItem asMCDefinition]) 
		to: item asMCDefinition! !

!ModifiedClassDefinitionEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:23'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:e| e includesClass: item]! !

!CategoryAdded methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:15'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!ClassCommented methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:49'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!ModifiedMethodEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 11:11'!
asMCPatchOperation
	^MCModification of: (oldItem asMCDefinition) to: (item asMCDefinition)! !

!ModifiedMethodEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:49'!
itemIsIncludedInMonticelloPackage
	^item itemIsIncludedInMonticelloPackage.! !

!ReorganizedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:25'!
asMCPatchOperation
	^MCModification of: (item asMCDefinition) to: (item asMCDefinition)! !

!ReorganizedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:23'!
itemIsIncludedInMonticelloPackage
	^PackageInfo allPackages anySatisfy: [:ea| ea includesClass: item]! !

TestCase subclass: #DevPacerTest
	instanceVariableNames: 'pacer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:28'!
setUp

	super setUp.
	pacer := DevPacer new.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:41'!
tearDown

	pacer disable.
	super tearDown.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
testDisabledAtFirst

	self deny: pacer isEnabled.
	self assert: Color gray equals: pacer stateColor.
	self assert: 'off' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:40'!
testEnable

	pacer enable.
	self assert: pacer isEnabled.
	self assert: Color green equals: pacer stateColor.
	self assert: 'well done!!' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 09:51'!
testFail

	"self fail."! !

!ClassAdded methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:53'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

SystemWindow subclass: #DevPacerWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacerWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:15'!
taskbarButtonFor: aTaskbar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^self theme
		newDevPacerTaskbarButtonIn: aTaskbar
		for: self! !

!DevPacerWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:51'!
taskbarButtonMenu: aMenu
	"Answer the menu for the task bar button."

	| menu theme |
	theme :=  self theme.
	menu := theme newMenuIn: self for: self.
	menu
		addToggle: 'Restore' translated
		target: self
		selector: #restore
		getStateSelector: nil
		enablementSelector: #isNotRestored.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Minimize' translated
		target: self
		selector: #minimize
		getStateSelector: nil
		enablementSelector: #isNotMinimized.
	menu lastItem
		icon: self theme windowMinimizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Maximize' translated
		target: self
		selector: #maximize
		getStateSelector: nil
		enablementSelector: #canBeMaximized.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu addLine.
	menu
		addToggle: 'Close' translated
		target: self
		selector: #closeBoxHit
		getStateSelector: nil
		enablementSelector: #allowedToClose.
	menu lastItem
		icon: self theme windowCloseForm;
		font: theme menuFont.
	menu add: 'Save' target: ImageSavePacer action: #buttonAction.
	^menu! !

!CategoryRenamed methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 17:32'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!AddedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 11:19'!
asMCPatchOperation
	^MCAddition of: (item asMCDefinition)! !

!AddedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 14:27'!
itemIsIncludedInMonticelloPackage
	^item itemIsIncludedInMonticelloPackage! !

Object subclass: #DevPacer
	instanceVariableNames: 'dueTime runningAni intervalMinutes pacerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:08'!
countDownString

	^(self dueTime - DateAndTime now) printString copyFrom:6 to: 10.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
defaultRunningAni

	^EndlessAni new
		stepTime: 500;
		operation: (MessageSend receiver: self selector: #pacerOperation).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:50'!
disable

	runningAni isNil ifFalse: [ runningAni stopStepping. runningAni := nil. ].! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
dueTime
	^ dueTime! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:48'!
dueTime: aDateTime
	dueTime := aDateTime! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:07'!
dueTimeHasExpired

	^self dueTime < (DateAndTime now).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:05'!
dueTimeIsNotSet

	^self dueTime isNil.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:39'!
enable

	^self runningAni startStepping.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
intervalMinutes
	^ intervalMinutes! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 6/10/2012 10:37'!
intervalMinutes: aNumber

	dueTime notNil
		ifTrue: 
			[dueTime := dueTime + (Duration minutes: aNumber-intervalMinutes)].
	intervalMinutes := aNumber.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:43'!
isEnabled

	^self runningAni isStepping.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:48'!
isRunning

	^self runningAni notNil and: [self runningAni isStepping].! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
messageString

	^self stateObject message value.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 11:24'!
pacerClass: unitPacerClass

	pacerClass := unitPacerClass.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation

	pacerClass pacerOperation.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni

	^runningAni setDefault: #defaultRunningAni for: self withSetter: #runningAni: .! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni: anAni

	runningAni := anAni.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:30'!
stateColor
	^self stateObject color.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:38'!
stateObject

	self isEnabled ifFalse: [^ISPState color: Color gray message: ['off']].
	^ISPState color: Color green message: ['well done!!'].! !

Object subclass: #ISPState
	instanceVariableNames: 'message color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ISPState class methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2012 17:34'!
color: aColor message: aString

	^self new
		color: aColor;
		message: aString  ! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:54'!
color

	^ color! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
color: aColor
	color := aColor! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message
	^ message! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message: aString
	message := aString! !

Object subclass: #PacerBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

PacerBase subclass: #CommitPacer
	instanceVariableNames: ''
	classVariableNames: 'ChangeOpSet GrandPatch NumberOfChangesTolerable'
	poolDictionaries: ''
	category: 'DevPacerCommon'!

CommitPacer class
	instanceVariableNames: 'Pacer'!

!CommitPacer commentStamp: 'HwaJong 5/8/2013 18:34' prior: 0!
commint in a good size is important for debugging or understanding history of a code. !

CommitPacer class
	instanceVariableNames: 'Pacer'!

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 15:01'!
buttonAction

	| modifiedPackages repo patches patchOperations grandPatch |
	modifiedPackages := MCPackage allInstances asSet select: [:pack| pack workingCopy modified].
		
	repo := MCCacheRepository allInstances anyOne.
	
	patches := modifiedPackages collect: [:pack| pack workingCopy changesRelativeToRepository: repo].
	
	patchOperations := OrderedCollection new.
	patches do: [:pat| patchOperations addAll: pat operations].
	grandPatch := MCPatch operations: patchOperations.
	self initializeChangeCounterWithPatchOperations: patchOperations.
	(PSMCPatchMorph forPatch: grandPatch) openInWindowLabeled: 'Grand Patch by DevPacer'.! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:38'!
buttonHelpString

	^'open diff window. open save window'! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 13:27'!
buttonLabelString

	^'open'! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 5/8/2013 09:39'!
changeCounter
^self changeOpSet size! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 5/8/2013 09:38'!
changeOpSet
	^ChangeOpSet setDefault: #defaultChangeOpSet for: self withSetter: #changeOpSet:! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 5/8/2013 09:38'!
changeOpSet: aSet
	ChangeOpSet := aSet! !

!CommitPacer class methodsFor: 'defaults' stamp: 'HwaJong 11/28/2012 08:43'!
defaultChangeCounter
^0! !

!CommitPacer class methodsFor: 'defaults' stamp: 'HwaJong 5/8/2013 11:58'!
defaultChangeOpSet
	^Dictionary new! !

!CommitPacer class methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
defaultIntervalMinutes
	^ 15! !

!CommitPacer class methodsFor: 'defaults' stamp: 'HwaJong 11/28/2012 16:03'!
defaultNumberOfChangesTolerable
^50! !

!CommitPacer class methodsFor: 'initialization' stamp: 'HwaJong 5/8/2013 14:19'!
dirtyWorkingCopies
	^(MCPackage allInstances collect: #workingCopy) asSet select: [:wc| wc modified]! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
getStatusText

	^self state message value! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
getStatusTextIsEnabled

	^true! !

!CommitPacer class methodsFor: 'states' stamp: 'hjo 5/16/2012 21:15'!
grayState

	^ISPState color: Color gray message: ['watching monticello is off'].! !

!CommitPacer class methodsFor: 'states' stamp: 'hjo 3/31/2012 14:11'!
greenState

	^ISPState color: Color green message: ['All packages are clean.']! !

!CommitPacer class methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:06'!
helpName

	^'commit pacer'! !

!CommitPacer class methodsFor: 'initialization' stamp: 'HwaJong 5/8/2013 15:00'!
initializeChangeCounter
	| repo |
	repo := MCCacheRepository allInstances anyOne.
	
	self changeOpSet: nil.
	self initializeChangeCounterWithPatchOperations: (Array streamContents: [:stream| ( self dirtyWorkingCopies collect: [:wc| wc changesRelativeToRepository: repo]) do: [:patch| stream nextPutAll: patch operations] ])
! !

!CommitPacer class methodsFor: 'initialization' stamp: 'HwaJong 5/8/2013 15:01'!
initializeChangeCounterWithPatchOperations: anArray
	
	self changeOpSet: nil.
	anArray do: [:po| self changeOpSet at: po literalKey put: po]
! !

!CommitPacer class methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 12:59'!
intervalMinutes
	self pacer intervalMinutes isNil
		ifTrue: [ self pacer intervalMinutes: self defaultIntervalMinutes ].
	^self pacer intervalMinutes! !

!CommitPacer class methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 12:59'!
intervalMinutes: anInteger

	self pacer intervalMinutes: anInteger.! !

!CommitPacer class methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
isRunning

	^self pacer isRunning.! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
morphPanel
	| statusText builder colorBar checkbox button |
	builder := UITheme builder.
	colorBar := builder newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	statusText := builder newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	button := builder newButtonFor: self action: #buttonAction getEnabled: nil label: self buttonLabelString help: self buttonHelpString.
	checkbox := builder
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ builder newGroupboxForAll: {builder newRow: {checkbox. builder newStack:{statusText . colorBar}. button}}.
! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 16:04'!
numberOfChangesTolerable
^NumberOfChangesTolerable setDefault: #defaultNumberOfChangesTolerable for: self withSetter: #numberOfChangesTolerable:! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 16:05'!
numberOfChangesTolerable: aSmallInteger 
NumberOfChangesTolerable := aSmallInteger ! !

!CommitPacer class methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 13:09'!
pacer

	Pacer isNil ifTrue: 
		[
			Pacer := SlimDevPacer new.
			Pacer pacerClass: self.
		].
	^Pacer.! !

!CommitPacer class methodsFor: 'running' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!CommitPacer class methodsFor: 'states' stamp: 'hjo 3/31/2012 14:05'!
redState

	^ISPState color: Color red message: ['COMMIT NOW!!!!'].    ! !

!CommitPacer class methodsFor: 'removing' stamp: 'HwaJong 11/28/2012 13:07'!
removePacer
Pacer := nil! !

!CommitPacer class methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
run

	self pacer enable.! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!CommitPacer class methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 16:03'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Number of changer per commit' translated;
		parent: #DevPacer;
		target: #CommitPacer; 
		getSelector: #numberOfChangesTolerable;
		setSelector: #numberOfChangesTolerable:;
		domainValues: #(5 10 20 30 50 100);
		default: self defaultNumberOfChangesTolerable;
		notInStyle.! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
shouldCheckboxEnabled

	^true! !

!CommitPacer class methodsFor: 'states' stamp: 'hjo 3/31/2012 12:19'!
somePackageIsDirty

	^MCWorkingCopy allManagers anySatisfy: [:wc| wc needsSaving ]  ! !

!CommitPacer class methodsFor: 'states' stamp: 'HwaJong 5/8/2013 09:40'!
state

	self isRunning not ifTrue: [^self grayState].
	self somePackageIsDirty ifFalse: [self changeOpSet: nil].
	self changeCounter = 0 ifTrue: [^self greenState].
	(self changeCounter <= self numberOfChangesTolerable) ifTrue: [^self yellowState].
	^self redState.
! !

!CommitPacer class methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
statusColor

	^self state color.! !

!CommitPacer class methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
stop

	self pacer disable.
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!CommitPacer class methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
strongStop

	self stop.
	self pacer runningAni: nil.! !

!CommitPacer class methodsFor: 'announcements' stamp: 'HwaJong 5/8/2013 15:22'!
systemChanged: aSystemAnnouncement
	aSystemAnnouncement itemIsIncludedInMonticelloPackage 
		ifTrue: [ | patchOp |
			patchOp := aSystemAnnouncement event asMCPatchOperation.
			self changeOpSet at: (patchOp literalKey) put: patchOp ].! !

!CommitPacer class methodsFor: 'polymorph' stamp: 'HwaJong 11/28/2012 12:58'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

!CommitPacer class methodsFor: 'removing' stamp: 'HwaJong 5/8/2013 18:54'!
versionStored: aMCVersion 
	|patchOperationToBeRemovedByVersionSave package|
	package := aMCVersion package.
	patchOperationToBeRemovedByVersionSave := self changeOpSet select: [:patchOperation| patchOperation belongsToPackage: package ].
	patchOperationToBeRemovedByVersionSave do: [:po| self changeOpSet removeKey: po literalKey ifAbsent: [] ].
	! !

!CommitPacer class methodsFor: 'states' stamp: 'HwaJong 11/28/2012 13:35'!
yellowState

	^ISPState color: Color yellow message: [self changeCounter printString, (self changeCounter > 1 ifTrue: [' changes'] ifFalse: [' change'])].! !

PacerBase subclass: #ImageSavePacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

ImageSavePacer class
	instanceVariableNames: 'Pacer'!

ImageSavePacer class
	instanceVariableNames: 'Pacer'!

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 3/16/2013 16:56'!
buttonAction

	SmalltalkImage current saveAsNewVersionDotNumber.! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:10'!
buttonHelpString

	^'Save new image version'! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'hjo 5/30/2012 18:58'!
buttonLabelString

	^'save'! !

!ImageSavePacer class methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/8/2013 18:50'!
countDownString

	^self pacer countDownString.! !

!ImageSavePacer class methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
defaultIntervalMinutes
	^ 2! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:50'!
getStatusText

	^self state message value! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:50'!
getStatusTextIsEnabled

	^true! !

!ImageSavePacer class methodsFor: 'states' stamp: 'hjo 5/16/2012 21:16'!
grayState

	^ISPState color: Color gray message: ['image monitoring is off'].! !

!ImageSavePacer class methodsFor: 'states' stamp: 'hjo 3/31/2012 12:13'!
greenState

	^ISPState color: Color green message: ['No need to save image.'].    
! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'image pacer'! !

!ImageSavePacer class methodsFor: 'system settings' stamp: 'HwaJong 5/8/2013 18:50'!
intervalMinutes
	self pacer intervalMinutes isNil
		ifTrue: [ self pacer intervalMinutes: self defaultIntervalMinutes ].
	^self pacer intervalMinutes! !

!ImageSavePacer class methodsFor: 'system settings' stamp: 'HwaJong 5/8/2013 18:50'!
intervalMinutes: anInteger

	self pacer intervalMinutes: anInteger.! !

!ImageSavePacer class methodsFor: 'running' stamp: 'HwaJong 5/8/2013 18:50'!
isRunning

	^self pacer isRunning.! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:51'!
morphPanel
	| statusText builder colorBar checkbox button |
	builder := UITheme builder.
	colorBar := builder newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	statusText := builder newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	button := builder newButtonFor: self action: #buttonAction getEnabled: nil label: self buttonLabelString help: self buttonHelpString.
	checkbox := builder
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ builder newGroupboxForAll: {builder newRow: {checkbox. builder newStack:{statusText . colorBar}. button}}.
! !

!ImageSavePacer class methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/8/2013 18:51'!
pacer

	Pacer isNil ifTrue: 
		[
			Pacer := DevPacer new.
			Pacer pacerClass: self.
		].
	^Pacer.! !

!ImageSavePacer class methodsFor: 'running' stamp: 'HwaJong 5/8/2013 18:51'!
pacerOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!ImageSavePacer class methodsFor: 'states' stamp: 'hjo 3/31/2012 14:12'!
redState

	^ISPState color: Color red message: ['SAVE NEW IMAGE NOW!!'].    ! !

!ImageSavePacer class methodsFor: 'running' stamp: 'HwaJong 5/8/2013 18:51'!
run

	self pacer enable.! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:51'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!ImageSavePacer class methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Image save pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #ImageSavePacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:51'!
shouldCheckboxEnabled

	^true! !

!ImageSavePacer class methodsFor: 'states' stamp: 'hjo 5/17/2012 11:08'!
state

	self isRunning not ifTrue: [^self grayState].
	self pacer dueTimeIsNotSet ifTrue: [ ^self greenState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!ImageSavePacer class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:51'!
statusColor

	^self state color.! !

!ImageSavePacer class methodsFor: 'running' stamp: 'HwaJong 5/8/2013 18:51'!
stop

	self pacer disable.
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!ImageSavePacer class methodsFor: 'running' stamp: 'HwaJong 5/8/2013 18:51'!
strongStop

	self stop.
	self pacer runningAni: nil.! !

!ImageSavePacer class methodsFor: 'interface' stamp: 'hjo 5/17/2012 11:04'!
systemChanged
	
	self pacer dueTimeIsNotSet
		ifTrue: [self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes)]
	! !

!ImageSavePacer class methodsFor: 'interface' stamp: 'hjo 5/17/2012 09:32'!
systemSaved

	self pacer dueTime: nil.
	self changed: #statusColor.
	self changed: #getStatusText.! !

!ImageSavePacer class methodsFor: 'system settings' stamp: 'HwaJong 5/8/2013 18:51'!
userStyleOn: aBuilder 
	<systemsettings>
	(aBuilder group: #DevPacer) label: 'DevPacer' translated! !

!ImageSavePacer class methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should save image after ', self countDownString].! !

!PacerBase class methodsFor: 'gui' stamp: 'HwaJong 5/8/2013 18:45'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'open AutoImageSave Morph')
		parent: #DevHelpers;
		order: 4;
		icon: self taskbarIcon;
		label: 'DevPacer';
		action: [ 
			| imageSavePanel commitPanel panel win |
			imageSavePanel := ImageSavePacer morphPanel.
			commitPanel := CommitPacer morphPanel.
			panel := UITheme builder newColumn: {imageSavePanel. commitPanel}.
			win := panel openInDevPacerWindowLabeled: 'DevPacer' inWorld: panel currentWorld.
			win extent:   (319.0@109.0).
			win model: self ]! !

!PacerBase class methodsFor: 'as yet unclassified' stamp: 'HwaJong 5/8/2013 18:46'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

Object subclass: #SlimDevPacer
	instanceVariableNames: 'runningAni pacerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
defaultRunningAni

	^EndlessAni new
		stepTime: 500;
		operation: (MessageSend receiver: self selector: #pacerOperation).! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
disable

	runningAni isNil ifFalse: [ runningAni stopStepping. runningAni := nil. ].! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
enable

	^self runningAni startStepping.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
isEnabled

	^self runningAni isStepping.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
isRunning

	^self runningAni notNil and: [self runningAni isStepping].! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
messageString

	^self stateObject message value.! !

!SlimDevPacer methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 13:06'!
pacerClass: unitPacerClass

	pacerClass := unitPacerClass.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation

	pacerClass pacerOperation.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
runningAni

	^runningAni setDefault: #defaultRunningAni for: self withSetter: #runningAni: .! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
runningAni: anAni

	runningAni := anAni.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
stateColor
	^self stateObject color.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
stateObject

	self isEnabled ifFalse: [^ISPState color: Color gray message: ['off']].
	^ISPState color: Color green message: ['well done!!'].! !

!ClassReorganized methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 16:16'!
itemIsIncludedInMonticelloPackage
	^event itemIsIncludedInMonticelloPackage! !

!RemovedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 12:24'!
asMCPatchOperation
	[^MCRemoval of: item asMCDefinition]
		on: MessageNotUnderstood 
		do: [:ex|
			ex receiver isObsolete
				ifTrue: [ |obsClass|
					obsClass := ex receiver.
					MCClassDefinition 
						name: ((obsClass name allButFirst: 'AnObsolete' size) asSymbol)
						superclassName: (obsClass superclass name)
						traitComposition: (obsClass traitComposition)
						classTraitComposition: (obsClass class traitComposition )
						category: (obsClass category)
						instVarNames: (obsClass instVarNames)
						classVarNames: (obsClass classVarNames)
						poolDictionaryNames: (obsClass poolDictionaryNames)
						classInstVarNames: (obsClass class instVarNames)
 						type: (obsClass typeOfClass)
						comment: (obsClass instanceSide organization classComment)
						commentStamp: (obsClass organization commentStamp)
					 ]
				ifFalse: [ ex signal ]
			]! !

!RemovedEvent methodsFor: '*DevPacerCommon' stamp: 'HwaJong 5/8/2013 15:08'!
itemIsIncludedInMonticelloPackage
	^item itemIsIncludedInMonticelloPackage! !
